<?php
ob_start();
header('Content-Type: text/html; charset=utf-8');

define('ROOT',dirname(__FILE__).'/');
require ROOT.'config.php';
$ROOT=ROOT;

ob_clean();

error_reporting(E_ALL & ~E_NOTICE);
date_default_timezone_set(TIMEZONE);
require ROOT.'user/library/db.class.php';
require ROOT.'user/library/str.class.php';
require ROOT.'user/library/user.class.php';
require ROOT.'user/library/cache.class.php';
require ROOT.'constant.php';//常量文件
require ROOT.'functions.php';//常用函数文件

// 数据过滤
if (!get_magic_quotes_gpc()){
    $_GET   = kc_addslashes_array($_GET);
    $_POST  = kc_addslashes_array($_POST);
    $_COOKIE= kc_addslashes_array($_COOKIE);
}

// AJAX跨域数据传递的时候，POST值设置为GET
if(!empty($_GET['jsoncallback'])){
	foreach($_GET as $key => $val){
		$_POST[$key] = $val;
	}	
	if(!empty($_GET['TID'])){
		$tid=$_GET['TID'];
		if(kc_validate($tid,1)){
			$array=file_get_contents(SERV.'/t_cache/'.$tid.'.php');
			$array=json_decode($array);
			foreach($array as $key =>$val){
				$_POST[$key]=$val;
			}
		}
	}
}

/* 全局变量 */
// CMD 传递页面执行参数
define('CMD',empty($_GET['CMD']) ? (empty($_POST['CMD'])?'':$_POST['CMD']) : $_GET['CMD']);

// 提交值的时候，指定METHOD=POST
define('METHOD',(kc_val($_POST,'METHOD')=='POST' ? 'POST' :'GET'));

// 是否ajax方式调用页面
define('AJAX',isset($_POST['AJAX']) ? true : false);

// 程序代号
define('PROD','content');

// 程序版本,必须为数字
define('VERSION',910);

// 小版本
define('VER',20);

// INC
define('INC',true);

//获得pid
define('PID',empty($_GET['pid']) ?1 :(kc_validate($_GET['pid'],2)?$_GET['pid']:1));

// 当前时间
define('TIME',time());

//今日
define('DAY',date('Ymd',TIME));

// 端口
define('PORT',$_SERVER['SERVER_PORT']);

// 当前完整URL地址
define('FULLURL','http://'.$_SERVER['SERVER_NAME'].(PORT==80?'':':'.PORT).DIR);

// 定义当前路径
define('URL',$_SERVER['REQUEST_URI']);

kc_object_to_array($_POST);

//页面及参数处理
$_GET=array_map('kc_trim',$_GET);
$_POST=array_map('kc_trim',$_POST);

/**
 * 去除字符串或数组左右空白
 * @param string $arr 数组或变量
 * @return $arr
 */
function kc_trim(&$arr){
	$arr=is_array($arr)
		? array_map('kc_trim',$arr)
		: trim($arr);
	return $arr;
}

if (CMD!='') {
	$func='_'.CMD;
	if(function_exists($func)){
		call_user_func($func);
	}else{
		kc_tip( '未定义的函数调用：'.$func.'()');
	}
	exit;
}

set_error_handler('error_handler',E_ERROR);

//用户访问限制 SWITCH:当页面不需要限制访问的时候设置SWITCH常量,升级页面需要
if(!defined('SWITCH')){
	if(kc_config('deny.switch')==1){
		require ROOT.'user/library/deny.class.php';
		new deny;
	}
}

if(!defined('AUTH_KEY')){
	if(kc_config('system.authkey')){
		define('AUTH_KEY',kc_config('system.authkey'));
	}else{
		define('AUTH_KEY',kc_config('system.salt'));
	}
}
/**
 * 将stdclass object转换成数组
 * @param string $arr 数组或变量
 * @return type
 */
function kc_object_to_array(&$arr){
    foreach ($arr as $k => $v){
        if (isset($v) && is_object($v)){
			unset($arr[$k]);
			$temp = get_object_vars($v);			
			foreach ($temp as $name => $value){					
				$arr[$k][$name]=$value;
			}
        }
    }
	return $arr;
}
/**
 * 转义
 * @param string $arr 数组或变量
 * @return type
 */
function kc_stripslashes_array(&$arr){
	$arr=is_array($arr)
		? array_map('kc_stripslashes_array',$arr)
		: stripslashes($arr);
	return $arr;
}
/**
 * 自动加载类
 * @param string $clsname 类名称，类对应的文件名称必须用小写,带默认值是为避免出错
 */
function __autoload($clsname=null){
	//当$clsname为空值的时候，应该是global.php?CMD=_autoload方式进行的调用
	if(empty($clsname)) exit(kc_tip('加载失败!'));
	$fpath=ROOT."user/library/{$clsname}.class.php";
	$fpath_apps=ROOT.'apps/'.$clsname.'/'.$clsname.'.class.php';
	if(file_exists($fpath)){
		require($fpath);
	}else if(file_exists($fpath_apps)){
		require($fpath_apps);
	}else{
		kc_tip('加载了不存在的类:'.$clsname);
	}
}
/**
 * 错误提示
 * @param integer$type 错误类型
 * @param string $msg 内容
 * @param string $file 发生文件
 * @param integer$line 行数
 */
function error_handler($type,$msg,$file,$line){
	echo "\n\n<h2>$msg</h2>\n<p>$file - <strong>$line</strong></p>\n\n";
}
/**
 * 输出json格式的ajax请求
 * @param type $array php数组
 */
function kc_ajax($array){
	if (empty($array)) exit('');

	if (isset($array['TITLE']) && isset($array['MAIN']) ) {
		if (empty($array['WIDTH']))
			$array['WIDTH']=320;
		if (empty($array['HEIGHT']))
			$array['HEIGHT']=100;
		if (empty($array['BUTTON'])) {
			$array['BUTTON']='';
		}
	}
	header('Content-Type: text/javascript; charset=utf-8');
	//admin提交
	if(empty($_GET['jsoncallback'])){
		exit(json_encode($array));
	}else{
		exit($_GET['jsoncallback'].'('.json_encode($array).')');
	}
}
/**
 * 获得配置参数
 * @param string $className 配置参数，句号分开,无句号的时候，返回类数组
 * @return string|array
 */
function kc_config($className){
	if (false === strpos($className,'.')) {//若没有的时候
		$class=$className;
	}else{
		list($class,$name)=explode('.',$className);
		$name=strtolower($name);
	}
	$global_class='kc_config_'.$class;
	if (empty($GLOBALS[$global_class])) {
		$db= new db;
		$class=$db->encode($class);
		$res=$db->getRows('%s_config','name,value',"class='$class'");
		$config=array();
		if ($res) {
			foreach ($res as $rs) {
				$config[strtolower($rs['name'])]=$rs['value'];
			}
		}
		$GLOBALS[$global_class]=$config;
		unset($config);
	}
	if (empty($name)) {
		if (isset($GLOBALS[$global_class])) {
			return $GLOBALS[$global_class];
		}else{
			return false;
		}
	}else{
		if (isset($GLOBALS[$global_class][$name])) {
			return $GLOBALS[$global_class][$name];
		}else{
			return false;
		}
	}
}

function kc_setConfig($className,$value){
	list($class,$name)=explode('.',$className);
	global $db;
	$db->update('%s_config',array('value'=>$value),"class='$class' and name='$name'");
}
/**
 * 当页面出现错误的时候调用
 * @param type $str 错误提示标题
 * @param string $type 提示类型,默认(error)错误提示；ok:提示成功;save:保存成功;update:更新成功;delete:成功删除;form:alert弹窗错误提示;go:切换到$str里指定的地址
 * @param string $but 按钮;enter:点击“确定”关闭;close:“关闭”;refresh:刷新当前页
 */
function kc_tip($str,$type='error',$but=null){
	//ajax页面的时候提示错误
	if (AJAX) {
		if($type=='form'){
			$js="alert('".$str."');\$('.Submit').removeAttr('disabled');";
			if(!empty($but)) $js.=$but;
			kc_ajax(array(
				'JS'=>$js,
			));
		}elseif($type=='go'){
			kc_ajax(array(
				'JS'=>"go('$str');",
			));
		}
		$main="<table>
			<tr>
				<th><img src=\"".DIR."images/confirm_".$type.".gif\"/></th>
				<td>$str</td>
			</tr>
		</table>";
		$titles=array(
			'error'=>'错误提示!',
			'ok'=>'成功操作!',
			'save'=>'保存成功!',
			'update'=>'更新成功!',
			'delete'=>'成功删除!',
		);
		$title=$titles[$type];
		$array=array(
			'TITLE'=>$title,
			'MAIN'=>$main,
			'ID'=>'kc_ajax',
			'WIDTH'=>400,
			'HEIGHT'=>180,
			'BUTTON'=>"<button onclick=\"\$.kc_close();return false;\">确定</button>",
		);		
		if(!empty($but)){
			if (is_array($but)) {
				$s='';
				foreach ($but as $key => $val) {
					$s.="<button onclick=\"go('".addslashes($val)."');return false;\">".addslashes($key)."</button>";
				}
				$but=$s;
			}elseif($but=='enter'){//确定关闭
				$but="<button onclick=\"\$.kc_close();return false;\">确定</button>";
			}elseif($but=='close'){//关闭提示
				$but="<button onclick=\"\$.kc_close();return false;\">关闭</button>";
			}elseif($but=='refresh'){//刷新来源页
				$but="<button onclick=\"go('".(empty($_POST['HTTP_REFERER'])?'./':$_POST['HTTP_REFERER'])."');$.kc_close();return false;\">确定</button>";
			}
			$array['BUTTON']=$but;
		}

		kc_ajax($array);
	}elseif(!empty($_GET['jsoncallback'])){
		$array=array('JS'=>"\$.kc_close();alert('$str');");
		exit($_GET['jsoncallback'].'('.json_encode($array).')');
	}else{
		@ob_end_clean();
		$error=$str;
		if(is_file(ROOT.T.'404.php')){			
			require ROOT.T.'404.php';
		}else{
			exit('<p>'.$error.'</p><p><a href="'.DIR.'">返回网站首页!</a></p>');
		}
		exit();
	}
	exit($s);
}
/**
 * 数组中获得值
 * @param array $array 有值的数组
 * @param string $val 键值
 * @param string $def 如果数组中没有键值的时候，返回这个值
 * @return string
 */
function kc_val($array,$val,$def=''){
	return isset($array[$val]) ? $array[$val] : $def;
}
/**
 * 获取HTTP POST方式传递值
 * @param string $name 要获取POST变量
 * @param integer $type 数据类型验证，详情请见kc_validate()
 * @param bool $is true的时候，必须有值
 * @return string
 */
function kc_post($name,$type=0,$is=0){
	//判断是否为通过admin平台传递来的值
	$post = isset($_POST[$name]) ? $_POST[$name] : false;
	if(!empty($post)){//如果有值，则判断类型
		if(!kc_validate($post,$type)){
			kc_tip('POST参数 '.$name.' 数据类型不正确');
		}
	}
	if($is && $post===false){//要求有值的时候判断
		kc_tip('POST参数 '.$name.' 不能为空');
	}
	return $post;
}
//获取$Q值内容并做验证
function kc_query($name,$type=0,$is=0){
	global $Q;
	$q=isset($Q[$name]) ? $Q[$name] : false;
	if(!empty($q)){
		if(!kc_validate($q,$type)){
			kc_tip('$Q['.$name.']数据类型不正确');
		}
	}
	if($is && $q===false){//要求有值的时候判断
		kc_tip('$Q['.$name.']不能为空');
	}
	return $q;
}
/**
 * 获取HTTP GET传递值
 * @param string $name 要获取的URL变量
 * @param integer $type 数据类型验证，详情请见kc_validate()
 * @param bool $is true的时候，必须有值
 * @return string
 */
function kc_get($name,$type=2,$is=0){
	$get = isset($_GET[$name]) ? $_GET[$name] : false;
	//若GET为空，则POST方式获取值
	if (AJAX==1 && $get===false) {
		$get = isset($_POST[$name]) ? $_POST[$name] : false;
	}
	if(!empty($get)){//如果有值，则判断类型
		if(!kc_validate($get,$type)){
			kc_tip('URL参数 '.$name.' 类型不正确!','form');
		}
	}
	if($is && $get===false){//要求有值的时候判断
		kc_tip('URL参数 '.$name.' 不能为空!','form');
	}
	return $get;
}
/**
 * 获得list复选框列表值
 * @param bool $is 验证是否为必须选择复选框 1必选 0可以不选
 * @param <int||string> $type 数据类型验证,详见kc_validate()
 * @return string
 */
function kc_getList($name='list',$is=1,$type=3){
	$list=kc_post($name);
	if($is && !($list)){
		kc_tip('请选择一个项目!');
	}
	if(!kc_validate($list,$type)){
		kc_tip('数据类型不正确!');
	}
	return $list;
}
/**
 * 读取Cookie
 * @param type $name COOKIE键值
 * @return string
 */
function kc_cookie($name){
	return empty($_COOKIE[$name]) ? '' : $_COOKIE[$name];
}
/**
 * 设置Cookie
 * @param string $name 键值
 * @param string $val 对应的值
 * @param integer$expire Cookie有效期
 */
function kc_setCookie($name,$val,$expire = 0) {
	$domain=$_SERVER['SERVER_NAME'];
	setcookie($name, $val,($expire ? time() + $expire : 0), '/',$domain);
}
/**
 * 编码转换
 * @param string $s   录入的
 * @param string $out 输出编码类型
 * @param string $in  输入编码类型
 * @return string
*/
function kc_iconv($s,$out='UTF-8',$in='GBK'){
	if($out==$in)
		return $s;
	if(function_exists('iconv')){
		$s=iconv($in,"$out//IGNORE",$s);
	}elseif(function_exists('mb_convert_encoding')){
		$s=mb_convert_encoding($s,$out,$in);
	}
	return $s;
}
/**
 * 字符串类型验证
 * @param string $s 要验证的字符串数据
 * @param <int|string|array> $type 数据类型，当为数组类型的时候，判断是否包含其值中
 * 0 : 任意字符
 * 1 : 数字和字母
 * 2 : 数字,无符号
 * 3 : 数字组合，逗号分开
 * 4 : 数字字母和下划线，中划线会有问题
 * 5 : 邮箱验证
 * 6 : 网址
 * 7 : 完整http图片地址 + 本地
 * 8 : 日期+时间 完整类型
 * 9 : 日期 类型
 * 10: 版本号 1.0.23
 * 11: IP地址
 * 12: 常数 1.001
 * 13: 数字、字符组合，逗号分开
 * 14: 颜色值，必须得写上#
 * 15: 标准路径 XXX/YYY/
 * 18: 日期+时间 完整不带秒
 * 22: 数字,有符号
 * 23: 第一个字符是字母,后面的由数字、字母和下划线构成
 * 24: 数字、字母和中下划线,用在目录验证
 * 25: base64_encode转换后的数据
 * 带符号的数字组合,逗号分开
 * 33: 带符号的数字组合,逗号分开
 * 34: 不匹配特殊符号，帐户验证的时候用
 * 35: 匹配手机号码
 * 36: 匹配电话号码
 * default: 自定义正则验证
 * @return bool 验证通过返回1，否则false
*/
function kc_validate($s,$type){
	$reg='';
	switch($type){
		case 1:$reg='/^[a-zA-Z0-9]+$/';break;
		case 2:$reg='/^[0-9]+$/';break;
		case 3:$reg='/^([0-9]+,)*[0-9]+$/';break;
		case 4:$reg='/^[A-Za-z0-9\_]+$/';break;
		case 5:
			$reg='/^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/';break;
		case 6:
			$reg='/^[a-zA-Z]{3,10}:\/\/[^\s]+$/';
			break;
		case 7:
			$reg='/^([a-zA-Z]{3,10}:\/\/)?[^\s]+\.(jpeg|jpg|gif|png|bmp)$/';
			break;
		case 8:
			$reg='/^((((1[6-9]|[2-9]\d)\d{2})-(0?[13578]|1[02])-(0?[1-9]|[12]\d|3[01]))|(((1[6-9]|[2-9]\d)\d{2})-(0?[13456789]|1[012])-(0?[1-9]|[12]\d|30))|(((1[6-9]|[2-9]\d)\d{2})-0?2-(0?[1-9]|1\d|2[0-8]))|(((1[6-9]|[2-9]\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))-0?2-29)) (20|21|22|23|[0-1]?\d):[0-5]?\d:[0-5]?\d$/';
			break;
		case 9:
			$reg='/^((((1[6-9]|[2-9]\d)\d{2})-(0?[13578]|1[02])-(0?[1-9]|[12]\d|3[01]))|(((1[6-9]|[2-9]\d)\d{2})-(0?[13456789]|1[012])-(0?[1-9]|[12]\d|30))|(((1[6-9]|[2-9]\d)\d{2})-0?2-(0?[1-9]|1\d|2[0-8]))|(((1[6-9]|[2-9]\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))-0?2-29))$/';
			break;
		case 10:$reg='/^\d?\.\d?\.\d{4}$/';break;
		case 11:$reg='/^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$/';break;
		case 12:$reg='/^(\d+(\.\d+)?)$/';break;
		case 13:$reg='/^([0-9A-Za-z]+,)*[0-9A-Za-z]+$/';break;
		case 14:$reg='/^#?[0-9A-Fa-f]{6}$/';break;
		case 15:$reg='/^([a-zA-Z0-9\_\-]+\/)+$/';
			$s=preg_replace('/\{([a-zA-Z0-9]+)\}/','$1',$s);//替换{ID}等类型为ID
			$path=preg_replace('/(([a-zA-Z0-9\_\-]+\/)*)([a-zA-Z0-9\_\-]+\/)/','$3',$s);
			break;
		case 17:$reg='/^([a-zA-Z]{3,10}:\/\/)[^\s]+$/';break;
		case 18:
			$reg='/^((((1[6-9]|[2-9]\d)\d{2})-(0?[13578]|1[02])-(0?[1-9]|[12]\d|3[01]))|(((1[6-9]|[2-9]\d)\d{2})-(0?[13456789]|1[012])-(0?[1-9]|[12]\d|30))|(((1[6-9]|[2-9]\d)\d{2})-0?2-(0?[1-9]|1\d|2[0-8]))|(((1[6-9]|[2-9]\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))-0?2-29)) (20|21|22|23|[0-1]?\d):[0-5]?\d$/';
			break;
		case 22:$reg='/^(\-|\+)?[0-9]+$/';break;
		case 23:$reg='/^[a-zA-Z][a-zA-Z0-9\_]*/';break;
		case 24:$reg='/^([a-zA-Z0-9\-_]+\/)+$/';break;
		case 25:$reg='/[a-zA-Z0-9\+\%]+(\=)*$/';break;
		case 33:$reg='/^(\-?[0-9]+\,?)+$/';break;
		case 34:$reg="/^[^\s!-\/:-@\[-`\{-~]+$/";break;
		case 35:$reg="/^1[3-5,8]{1}[0-9]{9}$/";break;
		case 36:$reg="/^([0-9]{3,4}-)?[0-9]{7,8}$/";break;
		default:$reg=$type;break;
	}
	//如果为数组类型
	if (is_array($reg)) {
		$bool=in_array($s,$reg);
	}else{
		$bool= empty($type)
			? true
			: (empty($reg) ? false : (bool)preg_match($reg,$s));
	}
	return $bool;
}

function sign_encode($attrib=array()){
	global $u;
	$userid=$u->info['userid'];
	$username=$u->info['username'];
	$salt=kc_config('system.salt');
	$db=new db;
	$res_auths=$db->getRows_join('%s_user_role_auth','%s_user_role_bind','auth','rid','rid','t2.userid='.$userid);
	$auths=array();
	foreach($res_auths as $r){
		$auths[]=$r['auth'];
	}	
	$arr=array(
		'SITENAME'=>kc_config('site.name'),
		'SITEURL'=>SITEURL,
		'URL'=>strtolower($_SERVER['SERVER_NAME']),
		'PORT'=>PORT,
		'PROD'=>PROD,
		'VERSION'=>VERSION,
		'PRE'=>DB_PRE,
		'USERID'=>$userid,
		'USERNAME'=>$username,
		'T'=>T,
		'DIR'=>DIR,
		'USERAUTH'=>md5(kc_cookie('userauth').SITEURL),
		'AUTH'=>implode(',',$auths),
		'VER'=>VER,
		'PATH_UP'=>PATH_UP,
	);
	ksort($arr);
	$param=http_build_query($arr);
	$param.='&SIGN='.md5($param.$salt);
	return SERV.'/?'.$param;
}

function sign_get($attrib=array()){
	$arry=array();
	$salt=kc_config('system.salt');	
	$arr=$attrib;
	$arr['GET']=1;
	$arr['SITEURL']=SITEURL;
	$arr['VERSION']=VERSION;
	$arr['PROD']=PROD;
	ksort($arr);
	$param=http_build_query($arr);
	$param.='&SIGN='.md5($param.$salt);
	return SERV.'/?'.$param;
}
/**
 * 操作日志
 * @param array $log 需要传递userid,app[应用],action[动作],cid[关联的ID],notes[备注内容]
 */
function kc_log($log){
	$str=new str;
	$log['ip']=$str->ip();
	$log['date']=time();
	$log['notes']=empty($log['notes'])?'':$log['notes'];
	$db=new db;
	$db->insert('%s_log',$log);
}
//检查并更新模板分页文件
function kc_checkUpdate(){
	if(PID==1) return;
	if(!defined(PATH)) return;
	$temp = PATH;
	if(empty($temp)) return;
	if(!is_file(ROOT.PATH.'index.php')) return;
	if(!is_file(ROOT.PATH.PID.'/index.php')) return;
	if(filemtime(ROOT.PATH.'index.php')>filemtime(ROOT.PATH.PID.'/index.php')){
		$file=new file;
		$s=$file->get(PATH.'index.php');
		$s=preg_replace("/^(<\?php )(require ')/","\$1\$_GET['pid']=".PID.";\$2../",$s);
		$file->put(PATH.PID.'/index.php',$s);
		header('location:'.FULLURL.PATH.PID.'/');
	}
}
//判断应用是否安装应用
function kc_checkApp($path){
	$db=new db;
	$path=$db->encode($path);
	return $db->getRows_one('%s_app','*',"path='$path'");
}
//递归方式的对变量中的特殊字符进行转义
function kc_addslashes_array($value){
    if (empty($value)){
        return $value;
    }else{
		return is_array($value) ? array_map('kc_addslashes_array', $value) : addslashes($value);
    }
}
?>