<?php
/**
* 文件操作类，可以直接访问
*/
class file{
/**
 * 创建引用文件
 * @param string $path 目标路径
 * @param string $array 缓存页面内容，必须提供$array[title]和$array[TEMPLATE]
 * @param string $incfile 被引用的文件路径
 * @return  成功返回true
 */
function create($path,$info,$incfile=false){
	if(empty($path)) return false;
	$s="<?php require '".(preg_replace('/[^\/]+\//','../',$path))."global.php';define('PATH','$path');";
	if(empty($info)){
		$s.="kc_tip('您正要访问的页面已被删除！');  ?>";
		$this->put($path.'index.php',$s);
	}
	$s.="kc_checkUpdate();";
	if(empty($info['title']) && empty($info['name'])) kc_tip('file::create函数第二个参数自对象title和name不能同时为空！','form');
	if(empty($info['title'])) $info['title']=$info['name'];
	foreach(array('name','keywords','description') as $v){
		$info[$v]=empty($info[$v])?$info['title']:$info[$v];
	}
	
	$s.="\$info=".var_export($info,true).";\$u=new user;global \$str,\$db,\$cache;";
	
	if($incfile){
		$s.="require ROOT.'$incfile';";
	}
	$s.="extract(\$info,EXTR_OVERWRITE);";
	$s.="require ROOT.'user/library/template.class.php';\$template=new template;";
	$s.="require ROOT.\$template->path(\$TEMPLATE);";

	$s.="?>";
	$this->put($path.'index.php',$s);
}

/**
 * 读取指定的目录下面的文件和文件夹列表
 * @param <type> $path 要读取的路径，必须以/结尾
 * @param string $type 遍历并返回的文件类型 *:所有文件和目录 dir:目录 file:文件 [ext]:指定扩展名，如：xml|doc
 * @param array $ignore 过滤的文件或目录名称
 * @return array 列表 array('不包含ROOT的完整路径'=>'文件名')
 */
function getDir($path='',$type='*',$ignore=array('.','..','.svn')){

	if (!is_dir(ROOT.$path)) {
		return array();
	}

	$dirs = $files = array();

	$handle=opendir(ROOT.$path);
	if($handle){
		while (false !== ($file=@readdir($handle))){
			$file=$this->encode($file);
			if(!in_array($file,$ignore)){

				if(is_dir(ROOT.$path.$file)){//如果是dir
					if($type=='*'||$type=='dir')
						$dirs[$path.$file]=$file;
				}else{//文件
					if($type=='*'||$type=='file'||preg_match("/^.+\.({$type})$/i",$file))
						$files[$path.$file]=$file;
				}
			}
		}
		closedir($handle);

		$union=array_merge($dirs,$files);
		return $union;
	}else{
		kc_tip('找不到指定的目录<br/>'.$path);
	}
}
/**
 * 根据文件类型返回目录
 * @param string $filetype 文件类型
 * @return string 目录
 */
public function fileType2path($filetype){
	switch ($filetype) {
		case 'template':
			$path=PATH_TEMPLATE;
			break;
		case 'image':
			$path=PATH_UP.'/'.PATH_UP_IMAGE;
			break;
		case 'media':
			$path=PATH_UP.'/'.PATH_UP_MEDIA;
			break;
		case 'flash':
			$path=PATH_UP.'/'.PATH_UP_FLASH;
			break;
		case 'file':
			$path=PATH_UP.'/'.PATH_UP_FILE;
			break;
		default:
			kc_tip('不支持当前类型');
			break;
	}
	return $path;
}
/**
 * 读取文件
 * @param string $filename 要读取的文件路径
 * @return string 文件内容
 */
public function get($filename){

	$s='';
	$filename=$this->encode($filename,1);

	if(empty($GLOBALS['file_get_contents_array']))
		$GLOBALS['file_get_contents_array']=array();

	if(is_file(ROOT.$filename)){//如果存在则读取

		$s='';
		$fh = fopen(ROOT.$filename,"r");
			while (!feof($fh)) {
			$s.=fgets($fh);
		}
		fclose($fh);
	}
	return $s;
}
/**
 * 把字符串写入文件，返回是否成功
 * @param string $filename 要写入的文件地址，相对于安装目录
 * @param string $s 要写入的文本内容
 * @param bool $is 当写入失败的时候，是否提示错误，默认为不提示
 * @return bool true:成功 false:写入失败
 */
function put($filename,$s,$is=false){

	$filename=$this->encode($filename,1);

	$this->md(dirname($filename));//创建目录

	//去掉bom
	if(substr($s,0,3)==pack("CCC",0xef,0xbb,0xbf)){
		$s=substr($s,3);
	}
	if( file_put_contents(ROOT.$filename,$s,LOCK_EX) !== false ) {//写入成功
		return true;
	}else{//写入失败
		if($is){
			kc_tip('文件写入失败!<br/>'.$filename);
		}
	}
}
/**
 * 递归方式创建目录
 * @param string $path 目录路径
 * @return bool true:成功创建目录 false:失败
 */
public function md($path){
	$path=$this->encode($path,1);
	if(!is_dir(ROOT.$path)){
		return @mkdir(ROOT.$path,0755,true);
	}
}
/**
 * 删除文件夹/删除目录
 * @param type $path 要删除的文件夹路径
 * @param type $is
 * @return type
 */
function rd($path,$is=0){

	$path=$this->encode($path,1);

	if(!is_dir(ROOT.$path)) return;

	$array=$this->getDir($path);
	foreach($array as $val){
		$file=$path.'/'.$val;
		if($val!=''){
			if(is_dir(ROOT.$file)){//目录
				$this->rd($file,1);
				rmdir(ROOT.$file);
			}else{
				$this->delete($file);
			}
		}
	}
	if(!$is && is_dir(ROOT.$path)){
		rmdir(ROOT.$path);
	}
}
/**
 * 删除文件
 * @param string $path 文件路径
 * @return bool true:成功 false:失败
*/
function delete($path){

	$path=$this->encode($path,1);

	if(is_file(ROOT.$path)){
		return unlink(ROOT.$path);
	}
	return false;
}
/**
 * 文件编码转换
 * @param string $s 传入的字符串
 * @param bool $is 默认读取，1的时候是写入
 * @return string 转换后的字符串
 */
public function encode($s,$is=0){

	$lang=kc_val($_SERVER,'HTTP_ACCEPT_LANGUAGE');

	if(substr($lang,0,5)=="zh-cn"){
		$code='GBK';
	}elseif(substr($lang,0,5) == "zh-tw"){
		$code='BIG5';
	}

	if(isset($code)){
		$s=$is ? kc_iconv($s,$code,'utf-8') : kc_iconv($s,'utf-8',$code);
	}
	return $s;
}
/**
 * 分析HTML代码，并把其中的远程图片抓取到本地
 * @param string $s 要分析的HTML代码
 * @return string HTML代码
 */
function grabImg($s,$userid=0){
	$dom=new simple_html_dom;
	$dom->load($s,true);
	foreach ($dom->find('img') as $g) {//$img='';完整的图片HTML代码
		$src=$g->src;
		$g->src=$this->saveImage($src,$userid);//设置新的图片路径地址
	}
	return $dom->outertext;
}
/**
 * 远程图片路径
 * @param string $s 本地图片路径
 */
function saveImage($s,$userid=0){
	if(empty($s)) return '';
	
	if(preg_match('/^https?:\/\/[^\/]*?('.preg_quote(SITEURL).')\//i',$s)){
		$fext=strtolower(substr(strrchr($s,'.'),1));
		if (!in_array(strtolower($fext),array('jpeg','jpeg','gif','png'))) {
			$fext='jpg';//sina等的图没有扩展名
		}
		$image=file_get_contents($s);
	}elseif(preg_match('/^data\:image\/(png|jpeg|jpg|gif)\;base64\,(.+?)$/',$s,$mat)){
		$fext=$mat[1];
		$image=base64_decode($mat[2]);
	}else{
		return $s;//如果是本域名，就不需要抓图
	}
	
	//创建目录
	$attach_subdir =date('y/m/d');
	$attach_dir = PATH_UP.'/'.$attach_subdir;
	$attach_subdirs=explode('/',$attach_subdir);
	$attach_temp=ROOT.PATH_UP;
	foreach($attach_subdirs as $r){$attach_temp.='/'.$r;
		if(!is_dir($attach_temp)){
			@mkdir($attach_temp, 0755);
			@fclose(fopen($attach_temp.'/index.html', 'w'));
		}
	}
	$str=new str;
	$name=time().$str->random(6,1).'.'.$fext;
	$filename=date("His").mt_rand(1000,9999).'.'.$fext;
	$target = $attach_dir.'/'.$filename;
	
	//抓图
	if(empty($image)) return $s;
	$file=new file;
	$file->put($target,$image);

	//图像写入失败的时候，直接返回地址
	if(!is_file(ROOT.$target)) return $s;

	$arr=getimagesize(ROOT.$target);
	//非图像文件的时候，删除!
	if(empty($arr)){
		@unlink(ROOT.$target);
		return $s;
	}
	list($width,$height)=$arr;
	$extension=strtolower(substr(strrchr($arr['mime'], '/'), 1));

	$fext=$extension=='jpg' ? 'jpeg' : strtolower($extension);
	$func='imagecreatefrom'.$fext;//加载图像函数
	$source=$func(ROOT.$target);
	$max_width=kc_config('system.image_width');
	$max_height=kc_config('system.image_height');
	if ($width>$max_width || $height>$max_height) {

		if($width>=$height*$max_width/$max_height){
			$newW=$max_width;
			$newH=($max_width/$width)*$height;
		}else{
			$newW=($max_height/$height)*$width;
			$newH=$max_height;
		}
		$thumb=imagecreatetruecolor($newW, $newH);

		// Resize
		imagecopyresampled($thumb, $source, 0, 0, 0, 0, $newW, $newH, $width, $height);
		$func='image'.$fext;
		imageantialias($thumb,True);
		$func($thumb,ROOT.$target);

		@chmod(ROOT.$target,0755);
	}
	//比较数据流通过md5加密后的结果，以免重复提交图片
	$md5=md5_file(ROOT.$target);

	$db=new db;
	$rs=$db->getRows_one('%s_up_image','image',"md5='$md5'");
	if(empty($rs)){
		$array=array(
			'path'=>substr($target,strlen(PATH_UP)+1),
			'date'=>TIME,
			'md5'=>$md5,
		);
		$id=$db->insert('%s_up_image', $array);
	}else{
		$id=$rs['image'];
		$file=new file;
		$file->delete($target);
	}
	$sql="INSERT INTO ".DB_PRE."_up_image_bind (userid,image) values ('$userid','$id') ON DUPLICATE KEY UPDATE image=image;";
	$db->query($sql);

	return FULLURL.'images/?'.$id.'.jpg';

}
/**
 * 上传文件
 * @param string $inputname FILE表单名称
 * @param string $filetype 文件类型
 * @param string $path 默认上传路径,根据config参数和当前时间计算,必须以/
 * @param integer $filesize 最大上传文件大小 单位KB
 * @return bool 当成功的时候，返回true
 */
public function uploadFile($inputname,$filetype='image',$path=null,$filesize=2048){
	if (!isset($_FILES[$inputname])) {
		return 4;
	}
	$upfile=$_FILES[$inputname];
	//上传错误的时候
	if (!empty($upfile['error'])) {
		return $upfile['error'];
	}

	$filename=$upfile['name'];//文件名
	$fext=strtolower(substr(strrchr($filename,'.'),1));
	//若常量未被定义，则退出
	$FILETYPE='EXT_'.strtoupper($filetype);//转为大写
	if (!defined($FILETYPE)) {
		return 1001;
	}		

	$filetypeValue=constant('EXT_'.strtoupper($filetype));//获得常量值
	//判断文件扩展名是否符合要求
	if (!preg_match('/^('.$filetypeValue.')$/',$fext)) {
		return 1002;
	}
	//判断文件大小
	$filesize *= 1024;//kb转换为字节
	if ($upfile['size']>$filesize) {
		return 1003;
	}

	//获得对应的上传分类目录
	$uppath=constant('PATH_UP_'.strtoupper($filetype));

    $str=new str;
	$name=time().$str->random(6,1).'.'.$fext;//新的文件名
	$localPath=empty($path) 
	? PATH_UP.'/'.$uppath.'/'.date(FORMAT_PATH,time()).'/'.$name
	: $path.$name;

	$this->md(dirname($localPath));
	move_uploaded_file($upfile['tmp_name'],ROOT.$localPath);

	return $localPath;//返回图片路径

}
/**
 * 返回文件类型ICO图片
 * @param string $filename 完整的文件名
 */
function ico($filename){

	$path=pathinfo($filename);
	$ext=strtolower(empty($path['extension']) ? 'dir' : $path['extension']);

	if(is_file(ROOT.'include/images/filetype/'.$ext.'.png')){
		$ico=$ext;
	}elseif (in_array($ext,array('html','shtm','shtml'))) {
		$ico='htm';
	}elseif(in_array($ext,array('sqlite','db3'))){
		$ico='db';
	}elseif(in_array($ext,array('jpg','jpeg','gif','png','bmp'))){
		$ico='img';
	}elseif(in_array($ext,array('rar','bz','bz2','7z'))){
	}else{
		$ico='sys';
	}
	return $ico;
}
/**
 * 拷贝指定的目录
 * @param string $strSrcDir 被拷贝的源目录
 * @param string $strDstDir 存放的目标目录
 * @param array $ignore 过滤的目录名称
 * @return bool 
 */
function copyDir($strSrcDir, $strDstDir, $ignore=array('.','..','.svn')){

	if(!is_dir($strSrcDir)) return false;

    if(!is_dir($strDstDir)){  
        if (!@mkdir($strDstDir, 0777)) return false;   
    }
	
	$files = scandir($strSrcDir);
	foreach($files as $file){
		if(!in_array($file,$ignore)){
			if(is_dir($strSrcDir.'/'.$file)){
				if (!$this->copyDir($strSrcDir.'/'.$file, $strDstDir.'/'.$file)) return false;
			}else{
				if (!copy($strSrcDir.'/'.$file, $strDstDir.'/'.$file)) return false;  
			}
		}
	}
	return true;
}
}
?>